Attaques par ARP spoofing et contre-mesures
-------------------------------------------

Sommaire
--------
Introduction

Description de l'ARP spoofing

Description de l'outil "arpwrap"

Conclusion

Introduction
------------
Beaucoup d'attaques rseau s'appuient sur l'usurpation d'identits
d'utilisateurs ou de machines. On peut voler le mot de passe d'un
utilisateur, on peut emprunter l'adresse IP d'une machine (IP spoofing)
ou son nom DNS (DNS spoofing). Une technique un peu moins connue
ou tout au moins nglige, consiste  emprunter l'adresse MAC d'une
machine. Cette attaque est appele ARP spoofing. 
Je suppose qu'on a accord moins d'importance  cette attaque parcequ'elle
ne peut tre effectue qu' partir du rseau local et parcequ'elle concerne
les couches basses du rseau (couche 2-3). Pourtant une majorit de sinistres
informatiques sont causs par des attaques internes. De plus des outils
trs aboutis (tels que dsniff) exploitent avec une efficacit redoutable
les possibilits de l'ARP spoofing.       
J'ai donc dvelopp un petit outil nomm "arpwrap" permettant  un admnistrateur
de se premunir contre l'ARP spoofing lorsqu'il se connecte sur un serveur local
(avec telnet ou ssh).

Cet article dcrit succintement les attaques par arpspoofing. Il dcrit
galement l'outil "arpwrap". En conclusion, nous proposerons quelques volutions
possibles pour les contre-mesures destines  combattre l'"arpspoofing".


Description de l'ARP spoofing
-----------------------------

Un rseau local s'appuie gnralement sur une technologie multi-points 
de type Ethernet ou Token-ring, le premier de ces types tant trs largement
rpandu. Ethernet et Tokenring appartiennent tous les deux au standard
IEEE 802 et utilisent donc un systme d'adressage physique commun: MAC.
Une machine dote d'une carte Ethernet possde donc deux adresses :
une adresse logique nomme adresse IP et une adresse physique nomme adresse MAC.

Supposons les machines A et B situes dans le mme rseau local Ethernet.
A souhaite s'adresser  B. A connait l'adresse IP de B, mais ne connait
pas son adresse MAC. Elle va donc transmettre un message destin  toutes
les machines du rseau local (broadcast Ethernet) demandant quelle est
l'adresse MAC correspondant  l'adresse IP de B. Puisque ce message
est diffus  tout le monde, B le reoit. Comme B reconnait dans ce message
sa propre adresse IP, elle rpond  A. Les autres machines ne rpondent pas
puisque la question de A ne les concerne pas.
quand A reoit la rponse de B, elle stocke dans une table temporaire (appele
cache ARP) la correspondance "adresse IP de B" / "adresse MAC de B". 
Ensuite elle entame le dialogue avec B (chacun des messages contenant  la fois 
l'adresse MAC de B et l'adresse IP de B). Le protocole que nous venons
de dcrire est appel ARP. Le cache ARP est rgulirement effac. Un enregistrement
dans le cache ARP possde une dure de vie variable selon les OS 
(gnralement entre 30mn et 1H00).

ARP possde cependant une faille de scurit importante. Une machine
mettra son cache ARP  jour ds qu'elle recevra une rponse ARP, qu'elle
ait pose une question ou non. 
Supposons un utilisateur Albert dote d'une machine A, et consultant son
courrier lectronique sur une machine M. Supposons galement un pirate
surnomm "Warzzz le rebelle" dot d'une machine W. les machines A, M et W
se situent toutes dans le mme rseau local switch. Puisque le rseau
est switch, quand A parle  M, Z ne peut pas entendre la conversation.
Il n'en serait pas de mme si le rseau tait bas sur des hubs ou 
un cble coaxial. Warzzz veut capturer le mot de passe "courrier" d'Albert. 
Warzzz va d'abord transformer sa machine W en routeur. Ensuite, il va
fabriquer de fausses rponses ARP contenant le message "La machine M
possde l'adresse IP M et l'adresse MAC W". Il va inonder la machine A
de ces rponses falsifies. Rsultat: A stocke dans son cache ARP
l'information "l'IP de M correspond  l'adresse MAC de W". Quand Albert
voudra consulter son courrier, tous ses paquets rseau seront dirigs
vers Z. Comme Z est un routeur, il rorientera les paquets de A vers la
machine M. au final A aura un dialogue normal avec M. Albert ne s'appercevra
de rien: tout fonctionne normalement ! Mais tout passe par Z, donc Warzzz pourra
espionner le traffic rseau et capturer le mot de passe courrier d'Albert.

L'ARP spoofing permet des attaques bien plus puissantes, notamment
sur les connexions rseau cryptes telles que SSH ou SSL. En effet, 
supposons que A tablisse une connexion crypte SSL avec M. Si Warrzz
procdait comme prcedemment, il ne pourrait qu'couter des paquets
rseau crypts, ce qui ne lui serait d'aucune utilit.
Par contre supposons qu'il "spoofe"  la fois les machines A et M.
Alors, le trafic de A vers M passe par Z (comme prcedemment), mais
le trafic de M vers A passe galement par Z.
Warzzz ne va plus se contenter d'couter les paquets, il va aussi
en substituer un certain nombres. En effet lors d'une connexion SSL,
le serveur donne une cl publique au client. Dans notre cas M
va donner une cl publique "clP"  A. Tout ce que A chiffre avec "clP",
seul M sera capable de le dchiffrer. Donc lorsque M voudra donner
sa cl publique  A, Warzz va capturer "clP" et donnera sa propre cl "clZ"
 A tout en se faisant passer pour M. Ainsi A va transmettre des donnes
que Warzzz pourra dcrypter. Warzzz retransmettra en suite ces donnes
 M en les rencryptant avec "clM" pour que le dialogue entre A et M
ait lieu normalement. SSL prvoit la ngociation d'une cl de session
entre deux interlocuteurs. Warzzz devra donc ngocier des cls de session
 la fois avec A et M.
Ce type d'attaque est appele "man in the middle". En thorie SSL ne devrait
pas y tre sensible car la cl publique du serveur est sense tre certifie
 l'aide d'un certificat lectronique. Quand A reoit "clZ", un message 
est affich  l'cran signifiant  l'utilisateur que "clZ" ne correspond 
aucun certificat officiel attribu  la machine M. Cependant une majorit
d'utilisateurs ont tendance  ignorer cet avertissement (en partie parce que
les certificats lectroniques sont encore peu rpandus).




Description de l'outil arpwrap
------------------------------

On, l'aura compris, l'arp spoofing est souvent utilis dans le but
de capturer des mots de passe. Une rponse possible est le chiffrement
des communications. Mais le dploiement d'une telle solution n'est pas
toujours aise. 
Il faut gnralement utiliser un systme d'encryption  cls asymtriques
doubl d'un mcanisme de garantie de cls publiques. 
Telnet ne peut fournir aucune protection. SSH contient un mcanisme
de garantie de cls trs rudimentaire et gure pratique  dployer
(il faut enregistrer la cl publique du serveur manuellement sur tous
les postes clients). En thorie SSL est l'outil idal grce  son
systme de certificats, mais l'tablissement d'un certificat officiel
possde un cot en temps et en argent non ngligeable. 
C'est pourquoi j'ai cr "arpwrap". Ce programme n'est pas bas
sur le chiffrement. En fait c'est un dtecteur d'arp spoofing.
"Arpwrap" n'est en aucun cas l'outil miracle. Ce n'est d'ailleurs pas un outil 
trs complexe  programmer. Mais il permettra  un administrateur de se connecter
 un serveur local sans craindre une attaque par ARP spoofing.
Arpwrap fonctionne de la manire suivante:
- on passe en argument de arpwrap la commande et la cible voulue.
  par exemple si on souhaite faire un telnet sur 10.0.0.120:
  arpwrap -c "telnet 10.0.0.120" -t 10.0.0.120
  Notez la rptition de l'adresse IP. En effet il se peut que vous
  vouliez accder  un serveur externe. Dans ce cas le pirate 
  tentera de spoofer l'adresse MAC de votre passerelle rseau.
  Il faut donc saisir la commade suivante:
  arpwrap -c "telnet <ip extrieure>" -t <ip de ma passerelle>
- Une fois les arguments saisis, arpwrap va questionner plusieurs
  fois la cible (prcise derrire l'option -t) sur son adresse MAC 
  gace  des requtes ARP. Arpwrap va enregistrer toutes les rponses 
  ARP pendant 1 seconde. Il va vrifier que toutes les rponses 
  concernant la cible teste sont semblables. Si ce n'est pas le cas, 
  arpwrap conclue  une tentative de spoof et refuse d'excuter la commande.
- Si toutes les rponses sont semblables, il compare quand mme
  ces rponses aux informations contenues dans le cache ARP local.
  Si arpwrap constate une diffrence, il conclue  une tentative
  de spoof ARP.       
  
  "arpwrap" a t test avec succs contre le programme "arpspoof"
  faisant partie de la bote  outils "dsniff". "arpwrap" ne peut
  s'excuter qu'avec les doits "superuser". 
  "arpwrap" est disponible gratuitement  l'adresse suivante:
  http://www.protego.net/tools/
  Tout commentaire ou remarque peut tre adress  nmonier@protego.net.
  Ils seront les bienvenus. J'essairais de rpondre rapidement.
  Il est dvelopp pour les plateformes linux. Un version Solaris
  est galement disponible. Cette dernire s'appuie sur les librairies
  libnet et libpcap. Sur Solaris, il faut donc d'abord installer
  libnet et libpcap.
  Pour connaitre la syntaxe d'arpwrap, executer "arpwrap" sans arguments.

  Merci  Julien Conan pour son aide prcieuse lors de la phase
  de debuggage.

Conclusion
----------
Il n'est pas vident de se protger contre l'ARP spoofing. Il est
difficilement envisageable de rformer le protocole ARP. 
Le chiffrement des communications et la certification des cls publiques
reprsentent une contre-mesure fiable mais potentiellement difficile
 mettre en oeuvre alors que la mise en oeuvre de l'ARP spoofing
semble remarquablement aise (voir outil dsniff).
"arpwrap" offre une rponse partiellement satisfaisante et temporaire
en attendant la gnralisation de l'utilisation des certificats.

Il est envisag d'amliorer "arpwrap" de la manire suivante:
- gnration d'un nombre alatoire de requtes ARP afin de parer
   une attaque synchrone.
- Automatisation du choix de la cible en fonction de la commande
  encapsule par arpwrap.
- Dveloppement d'un "arpwrap server" commercial s'insrant dans   
  les firewalls Checkpoint FW-1.
  
  
Nicolas Monier
consultant scurit
www.protego.net
   
     
    






