//
//les inclusions
//
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/if_ether.h>
#include <arpa/inet.h>
#include <sys/ioctl.h>
#include <net/if.h>

//
//dfinition des constantes
//
#define ETH_HW_ADDR_LEN 6
#define IP_ADDR_LEN 4
#define ARP_FRAME_TYPE 0x0806
#define ETHER_HW_TYPE 1
#define IP_PROTO_TYPE 0x0800
#define OP_ARP_REQUEST 1
#define OP_ARP_REPLY 2
#define in_addr_t u_int32_t

//
//dclaration des structures
//
struct arp_packet
{
   u_char targ_hw_addr[ETH_HW_ADDR_LEN];
   u_char src_hw_addr[ETH_HW_ADDR_LEN];
   u_short frame_type;
   u_short hw_type;
   u_short prot_type;
   u_char hw_addr_size;
   u_char prot_addr_size;
   u_short op;
   u_char sndr_hw_addr[ETH_HW_ADDR_LEN];
   u_char sndr_ip_addr[IP_ADDR_LEN];
   u_char rcpt_hw_addr[ETH_HW_ADDR_LEN];
   u_char rcpt_ip_addr[IP_ADDR_LEN];
   u_char padding[18];
};


struct arp_packet_feature
{
   short op_code;           //opration reply  ou request  
   char requested_ip[16];   //ip vise par la request
   char replied_ip[16];     //ip vise par un reply
   char replied_mac[18];    //mac vise dans un reply 
   char mac_info[18];       //mac donnne dans un reply
   char ip_info[16];        //ip donnee dans un reply
};

//
//dclaration des prototypes de fonctions
//
void die(const char*);
void get_local_hw_addr(char*, char*);
void get_local_ip_addr(char*, char*);
void put_hw_addr(u_char*, char*);
void put_ip_addr(struct in_addr*, char*);
void get_local_mac_addr(char*, char*);
void get_local_ip_addr(char*, char*);
char* get_ip_addr(u_char*);
char* get_hw_addr(u_char*);
void send_arp_packet(int, char*, struct arp_packet*);
int recv_arp_packet(int, struct arp_packet**); 
void init_arp_packet(struct arp_packet*, struct arp_packet_feature*, char*);
int create_arp_send_socket();
int create_arp_receive_socket(char*);
int arp_cache_lookup(char*, unsigned long, struct ether_addr*);
